diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/internet/model/tcp-socket-state.h ns-3.32/src/internet/model/tcp-socket-state.h
--- ns-3.31/src/internet/model/tcp-socket-state.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/internet/model/tcp-socket-state.h	2020-10-06 15:35:43.000000000 -0700
@@ -165,6 +165,11 @@
   uint32_t               m_initialCWnd      {0}; //!< Initial cWnd value
   uint32_t               m_initialSsThresh  {0}; //!< Initial Slow Start Threshold value
 
+  // Recovery
+  // This variable is used for implementing following flag of Linux: FLAG_RETRANS_DATA_ACKED
+  // and is used only during a recovery phase to keep track of acknowledgement of retransmitted packet.
+  bool                   m_isRetransDataAcked  {false}; //!< Retransmitted data is ACKed if true
+
   // Segment
   uint32_t               m_segmentSize   {0}; //!< Segment size
   SequenceNumber32       m_lastAckedSeq  {0}; //!< Last sequence ACKed
@@ -182,7 +187,10 @@
   // Pacing related variables
   bool                   m_pacing            {false}; //!< Pacing status
   DataRate               m_maxPacingRate     {0};    //!< Max Pacing rate
-  DataRate               m_currentPacingRate {0};    //!< Current Pacing rate
+  TracedValue<DataRate>  m_pacingRate {0};           //!< Current Pacing rate
+  uint16_t               m_pacingSsRatio {0};        //!< SS pacing ratio
+  uint16_t               m_pacingCaRatio {0};        //!< CA pacing ratio
+  bool                   m_paceInitialWindow {false}; //!< Enable/Disable pacing for the initial window
 
   Time                   m_minRtt  {Time::Max ()};   //!< Minimum RTT observed throughout the connection
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/internet/model/tcp-tx-buffer.cc ns-3.32/src/internet/model/tcp-tx-buffer.cc
--- ns-3.31/src/internet/model/tcp-tx-buffer.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/internet/model/tcp-tx-buffer.cc	2020-10-06 15:35:43.000000000 -0700
@@ -112,6 +112,18 @@
   m_maxBuffer = n;
 }
 
+bool
+TcpTxBuffer::IsSackEnabled (void) const
+{
+  return m_sackEnabled;
+}
+
+void
+TcpTxBuffer::SetSackEnabled (bool enabled)
+{
+  m_sackEnabled = enabled;
+}
+
 uint32_t
 TcpTxBuffer::Available (void) const
 {
@@ -312,8 +324,8 @@
           next++;
           if (next != m_sentList.end ())
             {
-              // Next is not sacked... there is the possibility to merge
-              if (! (*next)->m_sacked)
+              // Next is not sacked and have the same value for m_lost ... there is the possibility to merge
+              if ((! (*next)->m_sacked) && ((*it)->m_lost == (*next)->m_lost))
                 {
                   s = std::min(s, (*it)->m_packet->GetSize () + (*next)->m_packet->GetSize ());
                 }
@@ -638,6 +650,23 @@
       m_lostOut -= size;
     }
 }
+
+bool
+TcpTxBuffer::IsRetransmittedDataAcked (const SequenceNumber32& ack) const
+{
+  NS_LOG_FUNCTION (this);
+  for (const auto &it : m_sentList)
+     {
+       TcpTxItem *item = it;
+       Ptr<Packet> p = item->m_packet;
+       if (item->m_startSeq + p->GetSize () == ack && !item->m_sacked && item->m_retrans)
+         {
+           return true;
+         }
+     }
+  return false;
+}
+
 void
 TcpTxBuffer::DiscardUpTo (const SequenceNumber32& seq,
                           const Callback<void, TcpTxItem *> &beforeDelCb)
@@ -1362,7 +1391,15 @@
 TcpTxBuffer::AddRenoSack (void)
 {
   NS_LOG_FUNCTION (this);
-  NS_ASSERT (m_sentList.size () > 1);
+
+  if (m_sackEnabled)
+    {
+      NS_ASSERT (m_sentList.size () > 1);
+    }
+  else
+    {
+      NS_ASSERT (m_sentList.size () > 0);
+    }
 
   m_renoSack = true;
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/internet/model/tcp-tx-buffer.h ns-3.32/src/internet/model/tcp-tx-buffer.h
--- ns-3.31/src/internet/model/tcp-tx-buffer.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/internet/model/tcp-tx-buffer.h	2020-10-06 15:35:43.000000000 -0700
@@ -167,6 +167,18 @@
   void SetMaxBufferSize (uint32_t n);
 
   /**
+   * \brief check whether SACK is used on the corresponding TCP socket
+   */
+  bool IsSackEnabled (void) const;
+
+  /**
+   * \brief tell tx-buffer whether SACK is used on this TCP socket
+   *
+   * \param enabled whether sack is used
+   */
+  void SetSackEnabled (bool enabled);
+
+  /**
    * \brief Returns the available capacity of this buffer
    * \returns available capacity in this Tx window
    */
@@ -257,6 +269,14 @@
   void SetHeadSequence (const SequenceNumber32& seq);
 
   /**
+   * \brief Checks whether the ack corresponds to retransmitted data
+   *
+   * \param ack ACK number received
+   * \return true if retransmitted data was acked
+   */
+  bool IsRetransmittedDataAcked (const SequenceNumber32& ack) const;
+
+  /**
    * \brief Discard data up to but not including this sequence number.
    *
    * \param seq The first sequence number to maintain after discarding all the
@@ -598,6 +618,7 @@
   uint32_t m_dupAckThresh {0}; //!< Duplicate Ack threshold from TcpSocketBase
   uint32_t m_segmentSize {0}; //!< Segment size from TcpSocketBase
   bool     m_renoSack {false}; //!< Indicates if AddRenoSack was called
+  bool     m_sackEnabled {true}; //!< Indicates if SACK is enabled on this connection
 
   static Callback<void, TcpTxItem *> m_nullCb; //!< Null callback for an item
 };
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/internet/test/tcp-general-test.cc ns-3.32/src/internet/test/tcp-general-test.cc
--- ns-3.31/src/internet/test/tcp-general-test.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/internet/test/tcp-general-test.cc	2020-10-06 15:35:43.000000000 -0700
@@ -952,6 +952,22 @@
     }
 }
 void
+TcpGeneralTest::SetDelAckMaxCount (SocketWho who, uint32_t count)
+{
+  if (who == SENDER)
+    {
+      m_senderSocket->SetDelAckMaxCount (count);
+    }
+  else if (who == RECEIVER)
+    {
+      m_receiverSocket->SetDelAckMaxCount (count);
+    }
+  else
+    {
+      NS_FATAL_ERROR ("Not defined");
+    }
+}
+void
 TcpGeneralTest::SetUseEcn (SocketWho who, TcpSocketState::UseEcn_t useEcn)
 {
   if (who == SENDER)
@@ -969,6 +985,40 @@
 }
 
 void
+TcpGeneralTest::SetPacingStatus (SocketWho who, bool pacing)
+{
+  if (who == SENDER)
+    {
+      m_senderSocket->SetPacingStatus (pacing);
+    }
+  else if (who == RECEIVER)
+    {
+      m_receiverSocket->SetPacingStatus (pacing);
+    }
+  else
+    {
+      NS_FATAL_ERROR ("Not defined");
+    }
+}
+
+void
+TcpGeneralTest::SetPaceInitialWindow (SocketWho who, bool paceWindow)
+{
+  if (who == SENDER)
+    {
+      m_senderSocket->SetPaceInitialWindow (paceWindow);
+    }
+  else if (who == RECEIVER)
+    {
+      m_receiverSocket->SetPaceInitialWindow (paceWindow);
+    }
+  else
+    {
+      NS_FATAL_ERROR ("Not defined");
+    }
+}
+
+void
 TcpGeneralTest::SetInitialSsThresh (SocketWho who, uint32_t initialSsThresh)
 {
   if (who == SENDER)
@@ -1183,11 +1233,14 @@
 
       if (m_bytesLeftToBeAcked == 0 && m_tcb->m_rxBuffer->NextRxSequence () > m_lastAckedSeq)
         {
-          m_bytesLeftToBeAcked = m_tcb->m_rxBuffer->NextRxSequence ().GetValue () - 1 - m_bytesToAck;
+          m_bytesLeftToBeAcked = m_tcb->m_rxBuffer->NextRxSequence ().GetValue () - m_lastAckedSeq.GetValue ();
+          m_bytesLeftToBeAcked -= m_bytesToAck;
+          NS_LOG_DEBUG ("Setting m_bytesLeftToBeAcked to " << m_bytesLeftToBeAcked);
         }
       else if (m_bytesLeftToBeAcked > 0 && m_tcb->m_rxBuffer->NextRxSequence () > m_lastAckedSeq)
         {
           m_bytesLeftToBeAcked -= m_bytesToAck;
+          NS_LOG_DEBUG ("Decrementing m_bytesLeftToBeAcked to " << m_bytesLeftToBeAcked);
         }
 
       NS_LOG_LOGIC ("Acking up to " << ackSeq << " remaining bytes: " << m_bytesLeftToBeAcked);
@@ -1257,8 +1310,9 @@
     }
 
   // send another ACK if bytes remain
-  if (m_bytesLeftToBeAcked > 0 && m_tcb->m_rxBuffer->NextRxSequence () > m_lastAckedSeq)
+  if (m_bytesLeftToBeAcked > m_bytesToAck && m_tcb->m_rxBuffer->NextRxSequence () > m_lastAckedSeq && !hasFin)
     {
+      NS_LOG_DEBUG ("Recursing to call SendEmptyPacket() again with m_bytesLeftToBeAcked = " << m_bytesLeftToBeAcked);
       SendEmptyPacket (flags);
     }
 }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/internet/test/tcp-general-test.h ns-3.32/src/internet/test/tcp-general-test.h
--- ns-3.31/src/internet/test/tcp-general-test.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/internet/test/tcp-general-test.h	2020-10-06 15:35:43.000000000 -0700
@@ -587,23 +587,47 @@
    * \brief Forcefully set the initial cwnd
    *
    * \param who socket to force
-   * \param initialCwnd size of the initial cwnd
+   * \param initialCwnd size of the initial cwnd (segments)
    */
   void SetInitialCwnd (SocketWho who, uint32_t initialCwnd);
 
   /**
-   * \brief Forcefully set the ecn use on
+   * \brief Forcefully set the delayed acknowledgement count
    *
    * \param who socket to force
-   * \param useEcn Mode of ECN. Currently Off and On are supported.
+   * \param count value of delayed ACKs
+   */
+  void SetDelAckMaxCount (SocketWho who, uint32_t count);
+
+  /**
+   * \brief Forcefully set the ECN mode of use
+   *
+   * \param who socket to force
+   * \param useEcn Value representing the mode of ECN usage requested
    */
   void SetUseEcn (SocketWho who, TcpSocketState::UseEcn_t useEcn);
 
   /**
-   * \brief Forcefully set the initial ssth
+   * \brief Enable or disable pacing in the TCP socket
+   * 
+   * \param who socket
+   * \param pacing Boolean to enable or disable pacing
+   */
+  void SetPacingStatus (SocketWho who, bool pacing);
+
+  /**
+   * \brief Enable or disable pacing of the initial window
+   * 
+   * \param who socket
+   * \param pacing Boolean to enable or disable pacing of initial window
+   */
+  void SetPaceInitialWindow (SocketWho who, bool paceWindow);
+
+  /**
+   * \brief Forcefully set the initial ssthresh
    *
    * \param who socket to force
-   * \param initialSsThresh size of the initial ssth
+   * \param initialSsThresh Initial slow start threshold (bytes)
    */
   void SetInitialSsThresh (SocketWho who, uint32_t initialSsThresh);
 
